﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace FlexGridHtmlEdit
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            c1FlexGrid1.Rows.DefaultSize = 50;
            c1FlexGrid1.Rows[0].Height = 22;

            // create a data table with an HTML field
            DataTable dt = new DataTable();
            dt.Columns.Add("HTML", typeof(string));
            dt.Columns.Add("Plain Text", typeof(string));
            for (int i = 0; i < 100; i++)
            {
                dt.Rows.Add(GetHtml(8, "Lorem <em>ipsum</em> dolor sit amet, <u>consectetur</u> adipisicing elit, sed do eiusmod <strong>tempor incididunt</strong> ut labore et dolore magna aliqua."), "Plain text...");
            }

            // bind grid
            c1FlexGrid1.DataSource = dt;

            // make Html field conspicuous
            Column colHtml = c1FlexGrid1.Cols["HTML"];
            colHtml.Width = 400;
            colHtml.StyleNew.WordWrap = true;
            //_flex.Cols.Move(colNotes.Index, 3);

            c1FlexGrid1.DrawMode = DrawModeEnum.OwnerDraw;
            // use HtmlEditor class to edit values in the "C1Editor" column
            var editor = new HtmlEditor();
            editor.BorderStyle = BorderStyle.None;
            colHtml.Editor = editor;
        }

        string GetHtml(float fontSize, string html)
        {
            string bgColor = ColorTranslator.ToHtml(Color.LightGoldenrodYellow);
            return string.Format(
                "<html><body style='margin:0pt;padding:0pt;font-family:{0};font-size:{1}pt;background-color:{2}'><p>{3}</p></body></html>",
                Font.Name,
                fontSize,
                bgColor,
                html);
        }

        // use this C1SuperLabel control to render Html cells
        C1.Win.C1SuperTooltip.C1SuperLabel _html = new C1.Win.C1SuperTooltip.C1SuperLabel();
        private void c1FlexGrid1_OwnerDrawCell(object sender, OwnerDrawCellEventArgs e)
        {
            if (c1FlexGrid1.Cols[e.Col].Name == "HTML" && e.Row > 0)
            {
                // draw background
                e.DrawCell(DrawCellFlags.Background);

                // use the C1SuperLabel to draw the html text
                if (e.Bounds.Width > 0 && e.Bounds.Height > 0)
                {
                    _html.Text = c1FlexGrid1.GetDataDisplay(e.Row, e.Col);
                    _html.BackColor = Color.Transparent;
                    _html.DrawToGraphics(e.Graphics, e.Bounds);
                }
                // and draw border last
                e.DrawCell(DrawCellFlags.Border);

                // we're done with this cell
                e.Handled = true;
            }
        }

        private void c1FlexGrid1_SetupEditor(object sender, RowColEventArgs e)
        {
            if (e.Col == 1)
            {
                c1EditorToolStripStyle1.Editor = (HtmlEditor)c1FlexGrid1.Cols[e.Col].Editor;
            }
        }

        private void c1FlexGrid1_AfterEdit(object sender, RowColEventArgs e)
        {
            c1EditorToolStripStyle1.Editor = null;
        }
    }
}
